// CalibNumDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "UpdatesDlg.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "Device.h"
#include "DownloadDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "AlignDlg.h"
#include "WebNumDial.h"

#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Device.h"
#include "NewzDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"

#include "YahooTicker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCalibNumDlg property page

IMPLEMENT_DYNCREATE(CCalibNumDlg, CPropertyPage)

CCalibNumDlg::CCalibNumDlg() : CPropertyPage(CCalibNumDlg::IDD)
{
	//{{AFX_DATA_INIT(CCalibNumDlg)
	m_HiDeg = 0;
	m_HiVal = 0.0;
	m_LoDeg = 0;
	m_LoVal = 0.0;
	//}}AFX_DATA_INIT
}

CCalibNumDlg::~CCalibNumDlg()
{
}

void CCalibNumDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalibNumDlg)
	DDX_Text(pDX, IDC_HIDEG, m_HiDeg);
	DDV_MinMaxInt(pDX, m_HiDeg, -360, 360);
	DDX_Text(pDX, IDC_HIVAL, m_HiVal);
	DDX_Text(pDX, IDC_LOWDEG, m_LoDeg);
	DDV_MinMaxInt(pDX, m_LoDeg, -360, 360);
	DDX_Text(pDX, IDC_LOWVAL, m_LoVal);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCalibNumDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CCalibNumDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalibNumDlg message handlers

BOOL CCalibNumDlg::OnKillActive() 
{
	BOOL RetVal = CPropertyPage::OnKillActive();
	
	// If successfully killed (i.e. validation and DDE OK), copy result to device
	if (RetVal)
	{
		// Set up ticker data
		CYahooTicker* pDev = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
		pDev->m_HiVal = m_HiVal;
		pDev->m_HiDeg = m_HiDeg;
		pDev->m_LoDeg = m_LoDeg;
		pDev->m_LoVal = m_LoVal;

		// Ensure low deg vals are lower than hivals and less than 360 deg between them

		pDev->m_HiDeg = ( pDev->m_HiDeg + 360 ) %360 - 360;
		pDev->m_LoDeg = ( pDev->m_LoDeg + 360 ) %360 - 360;
		if (pDev->m_HiDeg < pDev->m_LoDeg) pDev->m_HiDeg += 360;
		if (pDev->m_HiDeg < 0)
		{
			pDev->m_HiDeg += 360;
			pDev->m_LoDeg += 360;
		}
	}

	return RetVal;
}

BOOL CCalibNumDlg::OnSetActive() 
{
	BOOL RetVal = CPropertyPage::OnSetActive();
	
	// Set up ticker data
	CYahooTicker* pDev = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_HiVal = pDev->m_HiVal;
	m_LoVal = pDev->m_LoVal;
	m_HiDeg = pDev->m_HiDeg;
	m_LoDeg = pDev->m_LoDeg;
	
	this->UpdateData( false );
	
	return RetVal;
}


