// Device.h: interface for the CDevice class.
//
//////////////////////////////////////////////////////////////////////

enum DeviceType
{
	DT_NULLDEVICE = 0,
	DT_XMITTER,			// Transmitter
	VDT_TICKERDEVS,		// device group - tickers
	DT_YAHOOTICKER,		// 2x40 LCD My Yahoo Tocker display 
	DT_MSNTICKER,		// msn ticker
	VDT_TIMEDEVS,		// device group - time
	DT_TIME,			// time now, local time zones
	DT_DATE,			// dates, various calendar systems
	DT_DAY,				// day of week, various calendar systems
	DT_WEEK,			// week number, western
	DT_YEAR,			// Year number, various calendars
	DT_SIDEREAL,		// Sidereal time
	VDT_DEVWEBDIALS,	// Web dials virtual
	DT_WEBNUMDIAL,		// Dial driven by number on web page
	DT_WEBTEXTDIAL,		// Dial driven by text on web page
	DT_WEBTIMEDIAL		// Dial driven by time on web page
};



#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDevicesDlg;

class CDevice  :  public CObject
{
DECLARE_SERIAL( CDevice );

public:
	CString m_DeviceName;	// Device name
	DeviceType m_DeviceType;	// Type of intrument
	CString m_ResultText;		// Update data to be shown on display tab
	CString m_strDeviceID;
	CString m_strURL;
	int m_iUpdate;
	char m_chid[5];
	BOOL m_bSleep;
	CTime m_Wake;
	CTime m_Sleep;

public:
	CDevice();
	CDevice( CDevice& dv);
	void operator=(CDevice& dv);
	virtual ~CDevice();
	void setDeviceName(LPCSTR str);
	CString& getDeviceName();
	DeviceType getDeviceType();
	void setDeviceType(DeviceType Type);
	void Update();
	void AddPages();
	void RemovePages();
	virtual void Serialize(CArchive &ar);
	void WebUpdate();
	void UpdateNow();
	void AlignMode( bool bMode );
	void AlignLeft();
	void AlignRight();
	void AlignFLeft();
	void AlignFRight();
	void TransmitMessage();
};

