// HotOffThePress.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>

#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Ports.h"
#include "DevicesDlg.h"
#include "Keywords.h"
#include "DownloadDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "AlignDlg.h"
#include "Device.h"
#include "YahooTicker.h"
#include "FindText.h"
#include "WebTextDial.h"
#include "WebNumDial.h"
#include "Xmitter.h"


#define VERSIONNO 1


#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHotOffThePressApp

BEGIN_MESSAGE_MAP(CHotOffThePressApp, CWinApp)
	//{{AFX_MSG_MAP(CHotOffThePressApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHotOffThePressApp construction

CHotOffThePressApp::CHotOffThePressApp()
{
	m_pCurrDev = NULL;
	m_pDevicesDlg = NULL;
	m_pAboutDlg = NULL;
	m_bExiting = false;
	m_ButItsMyFirstTime = false;
	m_iDev = -1;
	m_bDataUpdate = false;

	// Set com port as neutral
	m_iComPort = 0;


}

/////////////////////////////////////////////////////////////////////////////
// The one and only CHotOffThePressApp object

CHotOffThePressApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CHotOffThePressApp initialization

BOOL CHotOffThePressApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	InitializeThreads();

#ifdef _AFXDLL
//	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
//	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));


	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// create and load the frame with its resources

	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);

	// Let's see if this ever appears
	m_pMainWnd->SetWindowText( "Strange message" );

	// If device data exists, read in.  Otherwise create default devices
	if (!SerializeData(false))
	{
		// assume couldn't open because it didn't exist
		m_ButItsMyFirstTime = true;

		// Create default devices (CXmitter device already initialized)
		if (TICKERONLY)
		{
			m_Devs.AddTail( new CYahooTicker );
		}
		else
		{
			m_Devs.AddTail( new CXmitter );
		}

		// Save settings just in case cancel button is pressed later
		SerializeData(true);
	}

	// Open port
	CHotOffThePressApp* pApp = ((CHotOffThePressApp*)AfxGetApp());
	pApp->OpenPort();

	// The one and only window has been initialized, so show and update it if debugging
	// otherwise, hide it
	pFrame->ShowWindow(SW_HIDE);
//	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

// if first time, help out a bit
	if (m_ButItsMyFirstTime)
	{
/*		// see if want web page
		if (AfxMessageBox(IDS_WANTFIRSTTIMEPAGE, MB_YESNO ) == IDYES)
		{
			CString str;
			str.LoadString( IDS_HELPFIRSTURL );

			ShellExecute(NULL, NULL, str, NULL, NULL, SW_SHOWNORMAL );
		}
		else
*/		{
			AfxMessageBox(IDS_OKLOOKTASKBAR, MB_OK );
		}

		// Bring up dialog
		m_pMainWnd->PostMessage( WM_COMMAND, ID_POPUP_PREFERENCES );
	}


	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CHotOffThePressApp message handlers





/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

/*
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}
*/

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CHotOffThePressApp::OnAppAbout()
{
	CString str;
	str.LoadString( IDS_MENUHELPURL );

	ShellExecute(NULL, NULL, str, NULL, NULL, SW_SHOWNORMAL );
}


bool CHotOffThePressApp::SerializeData( bool bSave )
{
	if (bSave)
	{

		CString strFile;
		strFile.LoadString( IDS_DATAFILENAME );
		CFile fIn;
		CFileException eFE;
		fIn.Open( strFile, CFile::modeWrite | CFile::modeCreate, &eFE );

		if (eFE.m_cause != CFileException::none)
		{
			// open failure
			return false;
		}

		// opended file - write it
		CArchive ar(&fIn, CArchive::store);

		// Com Port
		ar << m_iComPort;
				
		//  Number of devices, XMitter not included
		ar << m_Devs.GetCount() - (TICKERONLY?0:1);

		// Save out each device
		// Get device type - ignore first device if !TICKERONLY, since this is com port
		for (long i= (TICKERONLY)?0:1 ; i<m_Devs.GetCount(); i++)
		{
			CDevice* pDev = m_Devs.GetAt( m_Devs.FindIndex( i ) );

			ar << (long)pDev->m_DeviceType;
			switch (pDev->m_DeviceType)
			{
			case DT_NULLDEVICE: 
				{
					pDev->Serialize( ar );
				}
				break;

			case DT_YAHOOTICKER: 
				{
					((CYahooTicker *) pDev)->Serialize( ar );
				}
				break;

			case DT_WEBNUMDIAL: 
				{
					((CWebNumDial *) pDev)->Serialize( ar );
				}
				break;

			case DT_WEBTEXTDIAL: 
				{
					((CWebTextDial *) pDev)->Serialize( ar );
				}
				break;

			default:
				AfxMessageBox( "serialization write error in CHotOffThePressApp.cpp"), MB_OK;
			}
		}	
	
	}
	else
	{
		// open file and read
		CString strFile;
		strFile.LoadString( IDS_DATAFILENAME );
		CFile fIn;
		CFileException eFE;
		fIn.Open( strFile, CFile::modeRead, &eFE );

		if (eFE.m_cause != CFileException::none)
		{
			// open failure
			return false;
		}

		// opended file - read it
		CArchive ar(&fIn, CArchive::load);

		// Reset device list
		while (!m_Devs.IsEmpty())
		{
			delete m_Devs.RemoveTail();
		}
		if (!TICKERONLY)
		{
			m_Devs.AddTail( new CXmitter );
		}

		// Com Port
		ar >> m_iComPort;
				
		//  Number of devices
		long nDev = 0;
		ar >> nDev;

		// Read in each device
		// Get device type
		for (long i=0; i<nDev; i++)
		{
			long iDevType = (long)DT_NULLDEVICE;
			ar >> iDevType;
			switch ((DeviceType)iDevType)
			{
			case DT_NULLDEVICE: 
				{
					CDevice * pNewDev = new CDevice;
					pNewDev->Serialize( ar );
					m_Devs.AddTail( pNewDev );
				}
				break;

			case DT_YAHOOTICKER: 
				{
					CYahooTicker * pNewDev = new CYahooTicker;
					pNewDev->Serialize( ar );
					m_Devs.AddTail( pNewDev );
				}
				break;

			case DT_WEBNUMDIAL: 
				{
					CWebNumDial * pNewDev = new CWebNumDial;
					pNewDev->Serialize( ar );
					m_Devs.AddTail( pNewDev );
				}
				break;

			case DT_WEBTEXTDIAL: 
				{
					CWebTextDial * pNewDev = new CWebTextDial;
					pNewDev->Serialize( ar );
					m_Devs.AddTail( pNewDev );
				}
				break;

			default:
				AfxMessageBox( "serialization read error in CHotOffThePressApp.cpp"), MB_OK;
			}
		}

	}

	return true;
}




/////////////////////////////////////////////////////////////////////////////
// CHotOffThePressApp message handlers


int CHotOffThePressApp::ExitInstance() 
{
	// Delete device list
	while (!m_Devs.IsEmpty())
	{
		CDevice* pDev = m_Devs.RemoveTail();
		switch (pDev->m_DeviceType)
			{
			case DT_NULLDEVICE: 
			case DT_XMITTER: 
				delete pDev; 
				break;

			case DT_YAHOOTICKER: 
				delete ((CYahooTicker*)pDev); 
				break;

			case DT_WEBNUMDIAL: 
				delete ((CWebNumDial*)pDev); 
				break;

			case DT_WEBTEXTDIAL: 
				delete ((CWebTextDial*)pDev); 
				break;

			default:
				AfxMessageBox( "serialization read error in CHotOffThePressApp.cpp"), MB_OK;
			}

	}
		
	return CWinApp::ExitInstance();
}



bool CHotOffThePressApp::OpenPort() 
{
	// return if unassigned
	if (m_iComPort==0) return true;

	// Activate RS232 port
	CString strCom;
	strCom.Format( "\\\\.\\COM%d", m_iComPort );
//	strCom.Format( "COM%ld", (long) m_iComPort );
	m_hComm = INVALID_HANDLE_VALUE;
	m_hComm = CreateFile( strCom, GENERIC_READ | GENERIC_WRITE, 0, 0, 
				OPEN_EXISTING, 0, 0);
	if (m_hComm==INVALID_HANDLE_VALUE) {
		AfxMessageBox( IDS_CANTOPENPORT, MB_OK );
		m_iComPort = 0;
		return false;
	}

	// Set up com config block
	DWORD CCSize = sizeof(m_CC);
	if (GetCommConfig( m_hComm, &m_CC, &CCSize) == 0 ) 
	{
		AfxMessageBox( IDS_CANTOPENPORT, MB_OK );
		return false;
	}

	// Set correct io
	m_CC.dcb.fDtrControl = DTR_CONTROL_DISABLE;
	m_CC.dcb.fRtsControl = RTS_CONTROL_DISABLE;
	m_CC.dcb.BaudRate = CBR_19200;
	m_CC.dcb.ByteSize = 8;
	m_CC.dcb.Parity = ODDPARITY; 
	m_CC.dcb.StopBits = ONESTOPBIT;

	if (SetCommConfig( m_hComm, &m_CC, CCSize) == 0 ) 
	{
		AfxMessageBox( IDS_CANTOPENPORT, MB_OK );
		return false;
	}

	// Check no flow control
	if (m_CC.dcb.fDtrControl == DTR_CONTROL_HANDSHAKE ||
		m_CC.dcb.fRtsControl == RTS_CONTROL_HANDSHAKE )
	{
		AfxMessageBox( IDS_CANTOPENPORT, MB_OK );
		return false;
	}

	// Check baud rate
	if (m_CC.dcb.BaudRate != CBR_1200 )
	{
		AfxMessageBox( IDS_CANTOPENPORT, MB_OK );
		return false;
	}

	// Set RTS and DTR
	if (EscapeCommFunction( m_hComm, SETDTR ) == 0) 
	{
		AfxMessageBox( IDS_CANTOPENPORT, MB_OK );
		return false;
	}

	if (EscapeCommFunction( m_hComm, SETRTS ) == 0)  
	{
		AfxMessageBox( IDS_CANTOPENPORT, MB_OK );
		return false;
	}

	// return OK
	return true;

}


bool CHotOffThePressApp::ClosePort() 
{
	// return if unassigned
	if (m_iComPort==0) return true;

	// Close
	if (CloseHandle( m_hComm ) == 0)  
	{
//		AfxMessageBox( IDS_CANTCLOSEPORT, MB_OK );
		return false;
	}

	// return OK
	return true;

}
