// HotOffThePress.h : main header file for the HOTOFFTHEPRESS application
//

#if !defined(AFX_HOTOFFTHEPRESS_H__73DE8F24_C70F_11D5_AD6F_444553540000__INCLUDED_)
#define AFX_HOTOFFTHEPRESS_H__73DE8F24_C70F_11D5_AD6F_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

// If TICKERONLY is true, devices tab is hidden and transmitter device is always visible

#define TICKERONLY true


#define WM_TRAY_NOTIFY WM_USER+0

/////////////////////////////////////////////////////////////////////////////
// CHotOffThePressApp:
// See HotOffThePress.cpp for the implementation of this class
//

class CDevice;
class CDevicesDlg;
class CAboutDlg;

class CHotOffThePressApp : public CWinApp
{
public:
	CHotOffThePressApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHotOffThePressApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	// Port Control
	bool OpenPort();
	bool ClosePort();
	HANDLE m_hComm;
	COMMCONFIG m_CC;
	bool m_bDataUpdate;

	// List of devices
	CList<CDevice*, CDevice*> m_Devs;

	// Current selected device
	CDevice* m_pCurrDev;
	int m_iDev;

	// Root dialogs
	CDevicesDlg* m_pDevicesDlg ;
	CAboutDlg* m_pAboutDlg ;

	// Port
	int m_iComPort;	// zero if not assigned

	// Internet Access
	CRobotInternet m_Internet;
	void InitializeThreads();

	bool m_bExiting;

	// Serialization
	bool SerializeData(bool bSave );

	// See if first run
	bool m_ButItsMyFirstTime;


public:
	//{{AFX_MSG(CHotOffThePressApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HOTOFFTHEPRESS_H__73DE8F24_C70F_11D5_AD6F_444553540000__INCLUDED_)
