// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>

#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Ports.h"
#include "DevicesDlg.h"
#include "Device.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "YahooTicker.h"
#include "Xmitter.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_SETFOCUS()
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_TRAY_NOTIFY, OnTrayNotify )
	ON_COMMAND( ID_POPUP_PREFERENCES, OnPreferences )
	ON_UPDATE_COMMAND_UI(ID_POPUP_PREFERENCES, OnPreferencesUpdate)
	ON_UPDATE_COMMAND_UI(ID_APP_ABOUT, OnAboutUpdate)
	ON_UPDATE_COMMAND_UI(ID_APP_EXIT, OnExitUpdate)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame() : m_TrayIcon( IDR_TRAYICON )
{
	m_bShutDown = FALSE;
	CTime t( 1999, 1, 1, 1, 1, 1 );
	m_LastWebUpdate = t;
	m_Message = 0;
	m_InTimerLoop = false;
}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	if (m_wndView.m_hWnd) m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


LRESULT CMainFrame::OnTrayNotify( WPARAM uID, LPARAM lEvent) 
{
	return m_TrayIcon.OnTrayNotification( uID, lEvent );
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// Set up Tray Icon
	m_TrayIcon.SetNotificationWnd( this, WM_TRAY_NOTIFY );
	m_TrayIcon.SetIcon( IDR_TRAYICON );

	// set up timer for one second
	SetTimer( 1, 1000, NULL );
		
	return 0;
}

void CMainFrame::OnPreferences()
{
	CHotOffThePressApp* pApp = ((CHotOffThePressApp*)AfxGetApp());

	// Create dialog
	if (TICKERONLY)
	{
		pApp->m_pDevicesDlg = new CDevicesDlg(IDS_DIALOGTITLETICKERONLY);
	}
	else
	{
		pApp->m_pDevicesDlg = new CDevicesDlg(IDS_DIALOGTITLE);
	}

	int nResponse = pApp->m_pDevicesDlg->DoModal();
	if (nResponse != IDCANCEL)
	{
		// Save data to file
		if (!pApp->SerializeData(true))
		{
			AfxMessageBox( IDS_CANTWRITETOFILE, MB_OK );
		}
	}
	else 
	{
		// Reload data from file
		if (!pApp->SerializeData(false))
		{
			AfxMessageBox( IDS_CANTREADFROMFILE, MB_OK );
		}
	}

	delete pApp->m_pDevicesDlg;
	pApp->m_pDevicesDlg = NULL;
	// Exit if Exit button pressed
	if (pApp->m_bExiting)
	{
		PostMessage( WM_COMMAND, ID_APP_EXIT );
	}


}

void CMainFrame::OnPreferencesUpdate(CCmdUI* pCmdUI) 
{
	// don't enable item if dialog is already up
	pCmdUI->Enable( ((CHotOffThePressApp*)AfxGetApp())->m_pDevicesDlg == NULL &&
		((CHotOffThePressApp*)AfxGetApp())->m_pAboutDlg == NULL);
}

void CMainFrame::OnAboutUpdate(CCmdUI* pCmdUI) 
{
	// don't enable item if dialog is already up
	pCmdUI->Enable( ((CHotOffThePressApp*)AfxGetApp())->m_pDevicesDlg == NULL &&
		((CHotOffThePressApp*)AfxGetApp())->m_pAboutDlg == NULL);
}

void CMainFrame::OnExitUpdate(CCmdUI* pCmdUI) 
{
	// don't enable item if dialog is already up
	pCmdUI->Enable( ((CHotOffThePressApp*)AfxGetApp())->m_pDevicesDlg == NULL &&
		((CHotOffThePressApp*)AfxGetApp())->m_pAboutDlg == NULL);
}


void CMainFrame::OnTimer(UINT nIDEvent) 
{
	if (m_InTimerLoop) return;

	m_InTimerLoop = true;
	CList<CDevice*, CDevice*>* Devs = &((CHotOffThePressApp*)AfxGetApp())->m_Devs;

	// Loop Through Devices and update if necesary - only do once per update frequency
	CTime tNow = CTime::GetCurrentTime();
	CTimeSpan tDiff = tNow - m_LastWebUpdate;
	if ( tDiff.GetTotalSeconds() >= Devs->GetAt(Devs->FindIndex(0))->m_iUpdate )
	{
		m_LastWebUpdate = tNow;
		
		// Loop through devices and tell them to update if needed

		for (int iDev = 0; iDev< Devs->GetCount(); iDev++)
		{
			Devs->GetAt(Devs->FindIndex(iDev))->WebUpdate();
		}
	}

	// Update next device
	m_Message++;
	if (m_Message >= Devs->GetCount()) m_Message = 0;

	if (Devs->GetCount()!=0) 
	{
		Devs->GetAt(Devs->FindIndex(m_Message))->TransmitMessage();
	}

	m_InTimerLoop = false;
	CFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::OnDestroy() 
{
	CFrameWnd::OnDestroy();
	// set up port and timer
	CHotOffThePressApp* pApp = ((CHotOffThePressApp*)AfxGetApp());
	pApp->ClosePort();
	KillTimer( 1 );
	
}
