// NoDeviceDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "CalibNumDlg.h"
#include "Keywords.h"
#include "DownloadDlg.h"
#include "FindNumDlg.h"
#include "AlignDlg.h"
#include "Device.h"
#include "NoDeviceDlg.h"
#include "AddDevice.h"
#include "YahooTicker.h"
#include "FindText.h"
#include "WebTextDial.h"
#include "WebNumDial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNoDeviceDlg property page

IMPLEMENT_DYNCREATE(CNoDeviceDlg, CPropertyPage)

CNoDeviceDlg::CNoDeviceDlg() : CPropertyPage(CNoDeviceDlg::IDD)
{
	//{{AFX_DATA_INIT(CNoDeviceDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CNoDeviceDlg::~CNoDeviceDlg()
{
}

void CNoDeviceDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNoDeviceDlg)
	DDX_Control(pDX, IDC_REMOVE, m_btRemove);
	DDX_Control(pDX, IDC_DEVICES, m_Devices);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNoDeviceDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CNoDeviceDlg)
	ON_LBN_SELCHANGE(IDC_DEVICES, OnSelchangeDevices)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNoDeviceDlg message handlers

BOOL CNoDeviceDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Fill list box with device list
	int i;
	CHotOffThePressApp* pApp = (CHotOffThePressApp*) AfxGetApp();
	CList<CDevice*, CDevice*>* Devs = &((CHotOffThePressApp*)AfxGetApp())->m_Devs;
	for (i=0; i<Devs->GetCount(); i++)
	{
		m_Devices.AddString( Devs->GetAt( Devs->FindIndex( i ) )->getDeviceName() );
	}

	// Check something is in list and set selection
	if (Devs->IsEmpty())
	{
		AfxMessageBox("Error NoDeviceDlg.cpp  -  Empty list m_Devs - create null device type to cover this situation with String value \'No devices inslatted\'");
	}
	else
	{
		if (pApp->m_iDev<0) pApp->m_iDev = Devs->GetCount()-1;

		m_Devices.SetCurSel( pApp->m_iDev );
		CList<CDevice*, CDevice*>* Devs = &(pApp->m_Devs);
		pApp->m_pCurrDev = Devs->GetAt( Devs->FindIndex( m_Devices.GetCurSel() ) );
	}
	
	// If first item selected (transmitter), disable remove button
	m_btRemove.EnableWindow( m_Devices.GetCurSel()>0 );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CNoDeviceDlg::OnSelchangeDevices() 
{
	// If current selection changed, must remove all other pages and add new ones as appropriate

	// Remove old pages
	CHotOffThePressApp* pApp = (CHotOffThePressApp*)AfxGetApp();
	pApp->m_pCurrDev->RemovePages();

	// Update CurrDev
	CList<CDevice*, CDevice*>* Devs = &(pApp->m_Devs);
	pApp->m_iDev = m_Devices.GetCurSel();
	pApp->m_pCurrDev = Devs->GetAt( Devs->FindIndex( pApp->m_iDev ) );
	
	// Add new pages
	pApp->m_pCurrDev->AddPages();

	// If first item selected (transmitter), disable remove button
	m_btRemove.EnableWindow( m_Devices.GetCurSel()>0 );

}

void CNoDeviceDlg::OnAdd() 
{
	// Create Dialog
	CAddDevice AddDev;

	// Go modal
	if (AddDev.DoModal()==IDOK)
	{
		
		// Creat new device
		CDevice* pNewDevice;

		switch (AddDev.m_dev)
		{
		case DT_YAHOOTICKER:
			pNewDevice = (CDevice*) new CYahooTicker;
			break;

		case DT_WEBNUMDIAL:
			pNewDevice = (CDevice*) new CWebNumDial;
			break;

		case DT_WEBTEXTDIAL:
			pNewDevice = (CDevice*) new CWebTextDial;
			break;

		default:
			AfxMessageBox("Don't know how to create that device in NoDeviceDlg.cpp");
			return;
		}
		
		// Add to list
		CList<CDevice*, CDevice*>* Devs = &((CHotOffThePressApp*)AfxGetApp())->m_Devs;
		Devs->AddTail( pNewDevice );
		m_Devices.AddString( pNewDevice->m_DeviceName );
		
		// Select new item in list
		m_Devices.SetCurSel( m_Devices.GetCount()-1 );
		OnSelchangeDevices();

	}

}

void CNoDeviceDlg::OnRemove() 
{
	// warn
	if (AfxMessageBox(IDS_NOGOINGBACK, MB_OKCANCEL) == IDOK)
	{

		// highlight previous item
		CList<CDevice*, CDevice*>* Devs = &(((CHotOffThePressApp*)AfxGetApp())->m_Devs);
		int iSelItem = m_Devices.GetCurSel();
		ASSERT( iSelItem>=1 );
		m_Devices.SetCurSel(iSelItem-1);
		OnSelchangeDevices();
		
		// delete item
		delete Devs->GetAt( Devs->FindIndex( iSelItem ) );
		Devs->RemoveAt( Devs->FindIndex( iSelItem ) );
		m_Devices.DeleteString(iSelItem);

	}
}
