// TimeTickerDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h" 
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Device.h"
#include "TimeTickerDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "YahooTicker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimeTickerDlg property page

IMPLEMENT_DYNCREATE(CTimeTickerDlg, CPropertyPage)

CTimeTickerDlg::CTimeTickerDlg() : CPropertyPage(CTimeTickerDlg::IDD)
{
	//{{AFX_DATA_INIT(CTimeTickerDlg)
	m_bTime = FALSE;
	m_ScrollRate = 0.0;
	//}}AFX_DATA_INIT
}

CTimeTickerDlg::~CTimeTickerDlg()
{
}

void CTimeTickerDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimeTickerDlg)
	DDX_Control(pDX, IDC_EDITFORMAT, m_TimeFormat);
	DDX_Check(pDX, IDC_SHOWTIME, m_bTime);
	DDX_Text(pDX, IDC_SCROLLRATE, m_ScrollRate);
	DDV_MinMaxDouble(pDX, m_ScrollRate, 0.1, 1000.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTimeTickerDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CTimeTickerDlg)
	ON_BN_CLICKED(IDC_RESTORE, OnRestore)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimeTickerDlg message handlers

BOOL CTimeTickerDlg::OnKillActive() 
{
	BOOL RetVal = CPropertyPage::OnKillActive();
	
	// If successfully killed (i.e. validation and DDE OK), copy result to device
	if (RetVal)
	{
		// Validate data -  no need

		// Set up ticker data
		CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
		pTicker->m_bTime = (m_bTime==0) ? false : true;
		m_TimeFormat.GetWindowText( pTicker->m_TimeFormatString );

		// m_ScrollRate is in seconds
		m_ScrollRate = m_ScrollRate*10 + 0.5;
		pTicker->m_ScrollRate = (int)m_ScrollRate;
	}

	return RetVal;
}

BOOL CTimeTickerDlg::OnSetActive() 
{
	BOOL RetVal = CPropertyPage::OnSetActive();
	
	// Set up ticker data
	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_bTime = pTicker->m_bTime;
	m_TimeFormat.SetWindowText( pTicker->m_TimeFormatString );
	m_ScrollRate = ((double)pTicker->m_ScrollRate) / 10.;
	
	this->UpdateData( false );
	
	return RetVal;
}

void CTimeTickerDlg::OnRestore() 
{
	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	CString str;

	str.LoadString( IDS_FACTORYTIME );
	m_TimeFormat.SetWindowText( pTicker->m_TimeFormatString );
	
}
