// UpdatesDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Device.h"
#include "UpdatesDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "YahooTicker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUpdatesDlg property page

IMPLEMENT_DYNCREATE(CUpdatesDlg, CPropertyPage)

CUpdatesDlg::CUpdatesDlg() : CPropertyPage(CUpdatesDlg::IDD)
{
	//{{AFX_DATA_INIT(CUpdatesDlg)
	m_dUpdate = 0.0;
	//}}AFX_DATA_INIT
}

CUpdatesDlg::~CUpdatesDlg()
{
}

void CUpdatesDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUpdatesDlg)
	DDX_Text(pDX, IDC_UPDATEFREQUENCY, m_dUpdate);
	DDV_MinMaxDouble(pDX, m_dUpdate, 0.1, 1000000.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUpdatesDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CUpdatesDlg)
	ON_BN_CLICKED(IDC_UPDATENOW, OnUpdatenow)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUpdatesDlg message handlers

void CUpdatesDlg::OnUpdatenow() 
{
	CWaitCursor wc;

	// Update in this thread
	CDevice* pDev = (CDevice*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	pDev->UpdateNow();
}

BOOL CUpdatesDlg::OnKillActive() 
{
	BOOL RetVal = CPropertyPage::OnKillActive();
	
	// If successfully killed (i.e. validation and DDE OK), copy result to device
	if (RetVal)
	{
		// Validate data -  no need

		// Set up  data
		CDevice* pDev = (CDevice*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
		// iUpdate is in seconds
		m_dUpdate = m_dUpdate*60 + 0.5;
		pDev->m_iUpdate = (int)m_dUpdate;
	}

	return RetVal;
}

BOOL CUpdatesDlg::OnSetActive() 
{
	BOOL RetVal = CPropertyPage::OnSetActive();
	
	// Set up  data
	CDevice* pDev = (CDevice*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_dUpdate =((double) ((int)pDev->m_iUpdate / 6) ) / 10.;

	// Change all '&' into '&&' in  data
	CString str;
	for (int i=0; i<pDev->m_ResultText.GetLength(); i++)
	{
		str += pDev->m_ResultText[i];
		if (pDev->m_ResultText[i] == '&') str += '&';
	}

	UpdateData( false );
	
	return RetVal;
}
