// WebNumDial.h: interface for the CWebNumDial (public CDevice) class.
//
//////////////////////////////////////////////////////////////////////

class CWebNumDial : public CDevice
{
DECLARE_SERIAL( CWebNumDial );

public:
	CWebNumDial();
	CWebNumDial( CWebNumDial& yt);
	virtual ~CWebNumDial();
	void AddPages( );
	void RemovePages( );
	void UpdateNow();
	void ParseWebPage( CString& sTicker, long &iResult, CString& sDoc, int RetVal, CString& sErr );
	void RemoveHTML(CString& str);
	virtual void Serialize(CArchive &ar);
	void WebUpdate();
	void TransmitMessage();

	// Property Sheets
	CDeviceIDDlg m_DeviceIDDlg;
	CSouceDlg m_SourceDlg;
	CDownloadDlg m_DownloadDlg;
	CFindNumDlg m_FindNumDlg;
	CCalibNumDlg m_CalibNumDlg;
	CAlignDlg m_AlignDlg;
	CUpdatesDlg m_UpdatesDlg;

	// Properties
	CTime m_LastWebUpdate;
	int m_iResult;					// angle of pointer
	BOOL	m_bOnFail;
	int		m_iHiDeg;
	double	m_dHiVal;
	int		m_iLoDeg;
	double	m_dLoVal;
	int		m_iOnFail;
	BOOL	m_bIsClock;			// true if is switec clock motor of 1440 seps rather
								// than regular 360 position pointer

	BOOL	m_bEuroFormat;
	int		m_iNumCount;

	BOOL	m_bCalcPercent;
	BOOL	m_bBefore;
	CString	m_sTriggerText;

};

